﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace TreeGridCore.Models
{
    public class TreeData
    {
        public static List<TreeData> tree = new List<TreeData>();
        [System.ComponentModel.DataAnnotations.Key]
        public int TaskID { get; set; }
        public string TaskName { get; set; }
      
        public int Duration { get; set; }
        public int? ParentValue { get; set; }
        public bool? isParent { get; set; }
        public TreeData() { }
        public static List<TreeData> GetTree()
        {
            if (tree.Count == 0)
            {
                int root = -1;
                for (var t = 1; t <= 10; t++)
                {
                    Random ran = new Random();
                    string math = (ran.Next() % 3) == 0 ? "High" : (ran.Next() % 2) == 0 ? "Release Breaker" : "Critical";
                    string progr = (ran.Next() % 3) == 0 ? "Started" : (ran.Next() % 2) == 0 ? "Open" : "In Progress";
                    root++;
                    int rootItem = tree.Count + root + 10000;
                    tree.Add(new TreeData() { TaskID = rootItem, TaskName = "Parent Task " + rootItem.ToString(),  isParent = true, ParentValue = null,  Duration = ran.Next(1, 50) });
                    int parent = tree.Count;
                    for (var c = 0; c < 10; c++)
                    {
                        root++;
                        string val = ((parent + c + 1) % 3 == 0) ? "Low" : "Critical";
                        int parn = parent + c + 1;
                        progr = (ran.Next() % 3) == 0 ? "In Progress" : (ran.Next() % 2) == 0 ? "Open" : "Validated";
                        int iD = tree.Count + root + 5000;
                        tree.Add(new TreeData() { TaskID = iD, TaskName = "Child Task " + iD.ToString(), isParent = (((parent + c + 1) % 3) == 0), ParentValue = rootItem, Duration = ran.Next(1, 50) });
                        if ((((parent + c + 1) % 3) == 0))
                        {
                            int immParent = tree.Count;
                            for (var s = 0; s < 3; s++)
                            {
                                root++;
                                string Prior = (immParent % 2 == 0) ? "Validated" : "Normal";
                                tree.Add(new TreeData() { TaskID = tree.Count + root + 1, TaskName = "Sub Task " + (tree.Count + root + 1).ToString(),  isParent = false, ParentValue = iD, Duration = ran.Next(1, 50) });
                            }
                        }
                    }
                }
            }
            tree = tree.OrderBy(o => o.TaskID).ToList();
         // tree = tree.ToList();
            return tree;
        }
    }
}
